<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die;

/**
 * FsrAmazon component helper.
 */
abstract class FsrAmazonHelper
{
	
	/**
	 * Adds manager icon.
	 */
	public static function addIcon() 
	{
		$document = JFactory::getDocument();
		$document->addStyleDeclaration('.icon-48-fsramazon {background-image: url(../media/com_fsramazon/images/fsr-48x48.png);}');
	}
	
	/**
	 * Configure the Linkbar.
	 */
	public static function addSubmenu($submenu) 
	{
		JSubMenuHelper::addEntry(JText::_('COM_FSRAMAZON_SUBMENU_MESSAGES'), 'index.php?option=com_fsramazon', $submenu == 'messages');
		JSubMenuHelper::addEntry(JText::_('COM_FSRAMAZON_SUBMENU_CATEGORIES'), 'index.php?option=com_categories&view=categories&extension=com_fsramazon', $submenu == 'categories');
		// set some global property
		$document = JFactory::getDocument();
		$document->addStyleDeclaration('.icon-48-fsramazon {background-image: url(../media/com_fsramazon/images/fsr-48x48.png);}');
		if ($submenu == 'categories') 
		{
			$document->setTitle(JText::_('COM_FSRAMAZON_ADMINISTRATION_CATEGORIES'));
		}
	}
	/**
	 * Get the actions
	 */
	public static function getActions($messageId = 0)
	{
		$user	= JFactory::getUser();
		$result	= new JObject;

		if (empty($messageId)) {
			$assetName = 'com_fsramazon';
		}
		else {
			$assetName = 'com_fsramazon.message.'.(int) $messageId;
		}

		$actions = array(
			'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.delete'
		);

		foreach ($actions as $action) {
			$result->set($action,	$user->authorise($action, $assetName));
		}

		return $result;
	}
}
