<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die;

// import the list field type
jimport('joomla.form.helper');
JFormHelper::loadFieldClass('list');

/**
 * FsrPaapiConfig Form Field class for the FsrAmazon component
 */
class JFormFieldFsrPaapiConfig extends JFormFieldList
{
	/**
	 * The field type.
	 *
	 * @var		string
	 */
	protected $type = 'FsrPaapiConfig';

	/**
	 * Method to get a list of options for a list input.
	 *
	 * @return	array		An array of JHtml options.
	 */
	protected function getOptions() 
	{
		$db = JFactory::getDBO();
		//$query = new JDatabaseQuery;
		$query = $db->getQuery(true);
		$query->select('id, label');
		$query->from('#__fsramazon_paapi_configs');
		$db->setQuery((string)$query);
		$configs = $db->loadObjectList();
		$options = array();
		
		if ($configs)
		{
			foreach($configs as $config) 
			{
				$options[] = JHtml::_('select.option', $config->id, $config->label);
				
			}
			
		}
		
		$options = array_merge(parent::getOptions(), $options);
		return $options;
	}
}
