<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

class resultset
{

    /**
     * xml document returned by aws ItemSearch
     *
     * @var SimpleXMLElement
     */
    protected $_xml;
	
    /**
     * creates an instance of resultset with help of xml document returned by aws ItemSearch
     *
     * @param  SimpleXMLElement $dom
     * @return void
     */
    public function __construct(SimpleXMLElement $xml)
    {
        $this->_xml = $xml;
        $this->_position = 0;
        $this->_items = $xml->Items;
    }

    /**
     * total number of results
     *
     * @return int total number of results
     */
    public function getTotalResults()
    {
        return (int) $this->_xml->Items->TotalResults;
    }

    /**
     * total number of pages
     *
     * @return int total number of pages
     */
    public function getTotalPages()
    {
        return (int) $this->_xml->Items->TotalPages;
    }
    
    /**
     * get items
     *
     * @return items
     */
    public function getItems()
    {
        return $this->_xml->Items->Item;
    }
	
}

