<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once 'components/com_fsramazon/amazon/amazon.php';
require_once 'components/com_fsramazon/helpers/fsrformatter.php';

// import Joomla controller library
jimport('joomla.application.component.controller');

/**
 * Fsr Amazon Component Controller
 */
class FsrAmazonController extends JController
{
	
	function display() 
	{
		
		$uri = JRequest::getURI();
		
//		$pos = strpos($uri, 'index.php?');
//		
//		if($pos === false)
//		{
//			throw new exception("Da ein Fehler");
//		}
//		
//		$menuLink = substr($uri, $pos);

		//get applicaton
		$app   = JFactory::getApplication();
		
		//get models
		$fsrPaapiConfigModel = $this->getModel('FsrPaapiConfig');		
		
		$fsrMenuMemoryModel = $this->getModel('FsrMenuMemory');		
		
//		$isAFirstPage = JRequest::getVar('page') == '' ? true : false;
		
		$menu   = $app->getMenu();
		
		// get global params
		$params = $app->getParams();
		
		//get config
		$fsrPaapiConfig = $fsrPaapiConfigModel->getConfig();
		
		$awsAccessKeyId = $fsrPaapiConfig->access_key;
		$awsSecretAccessKeyId = $fsrPaapiConfig->secret_access_key;
		$fsrAssociateTag = $fsrPaapiConfig->associate_tag;
		
/*
 * not needed because joomla pagination is used
 */
 
//		$currentPage = $isAFirstPage ? 1 : JRequest::getVar('page');

		$currentPage = JRequest::getVar('start') == '' ? 0 : JRequest::getVar('start');
		
		if ($currentPage == 0)
		{
			// expired menu items will be removed
			$fsrMenuMemoryModel->refreshMenuItems();
		}
		
		$amazon = new amazon($awsAccessKeyId, $params->get('domain'), $fsrAssociateTag, $awsSecretAccessKeyId);
		
		$options = array(
			'SearchIndex' => $params->get('category'),
			'Keywords' => $params->get('keywords'),
			'ItemPage' => $currentPage + 1
		);
		
		$resultset = $amazon->itemSearch($options);
		
		$maxAvailablePageNum = $resultset->getTotalPages();
		
		if (is_object($menu)) {

			$menuItem = $menu->getItem(JRequest::getVar('Itemid'));

/*
 * not needed because joomla pagination is used
 */
 	
//			//only first pages are initiator pages
//			if($isAFirstPage)
//			{
				
				$maxItemNum = ($params->get('max_item_num')) ? $params->get('max_item_num') : 100;
				// 'ALL' category only allows 50 items (5 pages) 
				$maxItemNum = ($params->get('category') == 'All') ? 50 : $maxItemNum;
				
				$maxPageNum = min($maxItemNum/10, $maxAvailablePageNum);
				

/*
 * not needed because joomla pagination is used
 */

//				$isAExpiredPage = $fsrMenuMemoryModel->isExpired($menuItem->id, $isAFirstPage);
//				
//				if($isAExpiredPage)
//				{
//					// expired menu items will be removed
//					$fsrMenuMemoryModel->refreshMenuItems();
//					
//					//refresh initiator page
//					$fsrMenuMemoryModel->create($menuItem->id, null, $params->get('refresh_interval'), true);
//					
//					for($i = 2; $i <= $maxPageNum; $i++)
//					{
//						//generate new menu item and menu memory 
//						$newItem =& $this->createMenuItem2($menuItem, $i);
//						$fsrMenuMemoryModel->create($newItem->id, $menuItem->id, $params->get('refresh_interval'), false);
//					}
//				}
//				else if($params->get('refresh_interval') == 'always') //expire pages manually
//				{
//					
//					$fsrMenuMemoryModel->removeByParent($menuItem->id);					
//					
//					$fsrMenuMemoryModel->create($menuItem->id, $params->get('refresh_interval'), true);
//					
//				}
//			
//			}
						
			//generate item pages
			if($params->get('index_behavior') == 'item_page')	
			{

				foreach($resultset->getItems() as $item)
				{
					$itemLinkArray = JFsrFormatter::itemAdditionalLinkData($params->get('domain'), $item->ItemAttributes->Title, $item->ASIN);
					$itemLinkArray['asin'] = $item->ASIN;
					
					$isAExpiredItemPage = $fsrMenuMemoryModel->isExpired($menuItem->id, false, $itemLinkArray['asin']);					
					
					if($isAExpiredItemPage || $params->get('refresh_interval') == 'always')
					{
						//remove menu item
						$fsrMenuMemoryModel->removeByAsin($itemLinkArray['asin']);
						
						//generate new menu item and menu memory 
						$id = $this->createMenuItem2($menuItem, 0, $itemLinkArray);
						$fsrMenuMemoryModel->create($id, $menuItem->id, $params->get('refresh_interval'), false, $itemLinkArray['asin']);
					}
				}
				
				if($params->get('url_path') == 'use_path')
				{	
					//rebuild menu
					$table = JTable::getInstance('Menu', 'JTable', array());
					
					$table->rebuild();
				}	
				
			}			
			
		}
		
		// get the view
		$view = $this->getView('FsrAmazon', 'html');
		
		//assign resultset to view
		$view->resultset = $resultset;
		
		//assign global params to the view
		$view->params = $params;
		
		//assign associate tag params to the view
		$view->associateTag = $fsrAssociateTag;
		
		//assign parent path to the view
		if (is_object($menu) && ($params->get('url_path') == 'use_path'))
		{

			$menuItem = $menu->getItem(JRequest::getVar('Itemid'));
			
			$db = &JFactory::getDBO();
			$db->setQuery('SELECT path FROM #__menu WHERE id = '.$menuItem->id);

			$view->parentPath = $db->loadResult();;
			
		}
		else
		{
			$view->parentPath = "";
		}
		
		//assign pagination to the view
		jimport('joomla.html.pagination');
		$view->pagination = new JPagination($maxPageNum, $currentPage, 1);
		
		$bannedProducts = $params->get('banned_products');
		
		$bannedProductArray = $bannedProducts != '' ? explode(',', $bannedProducts) : array();
		$finalBannedProductArray = array();
		
		$regex = array('#^[\s]{1,}#', '#[\s]{1,}$#');
		
		foreach($bannedProductArray as $bannedProduct)
		{
			$finalBannedProductArray[] = preg_replace($regex, '', $bannedProduct);			
		}
		
		$view->bannedProducts = $finalBannedProductArray;
		
		//setting default model
		$view->setModel($fsrPaapiConfigModel, true);
				
		$view->display();
	}
	
	function item()
	{
		
		//get applicaton
		$app   = JFactory::getApplication();
		
		//get asin
		$asin = JRequest::getVar('asin');
		
		//get menu
		$menu   = $app->getMenu();
		
		//get models
		$fsrPaapiConfigModel = $this->getModel('FsrPaapiConfig');
		
		// get global params
		$params = $app->getParams();
				
		//get config
		$fsrPaapiConfig = $fsrPaapiConfigModel->getConfig();
		
		$awsAccessKeyId = $fsrPaapiConfig->access_key;
		$awsSecretAccessKeyId = $fsrPaapiConfig->secret_access_key;
		$fsrAssociateTag = $fsrPaapiConfig->associate_tag;

		$amazon = new amazon($awsAccessKeyId, $params->get('domain'), $fsrAssociateTag, $awsSecretAccessKeyId);
		
		$options = array(
			'ItemId' => $asin
		);
		
		$item = $amazon->itemLookup($options);
		
		$view = $this->getView('FsrAmazonItem', 'html');
		
		$bannedProducts = $params->get('banned_products');
		
		$bannedProductArray = $bannedProducts != '' ? explode(',', $bannedProducts) : array();
		$finalBannedProductArray = array();
		
		$regex = array('#^[\s]{1,}#', '#[\s]{1,}$#');
		
		foreach($bannedProductArray as $bannedProduct)
		{
			$finalBannedProductArray[] = preg_replace($regex, '', $bannedProduct);			
		}
		
		$view->bannedProducts = $finalBannedProductArray;
		
		foreach($finalBannedProductArray as $bannedSimilarProduct)
		{
				
			$pos = strpos(strtolower($item->ItemAttributes->Title), strtolower($bannedSimilarProduct));
			
			if ($pos !== false)
			{							
				// raise an error
				JError::raiseError(
				404,
				JText::_('COM_FSRAMAZON_PRODUCT_NOT_FOUND'));		
			}
		}
			
		
		$similarProducts = array();
		
		if($item->SimilarProducts)
		{
			
			foreach($item->SimilarProducts->SimilarProduct as $similarProduct)
			{
				$addProduct = true;
				
				if(count($similarProducts) < $params->get('similar_products_num'))
				{					
					$similarProductOptions = array(
						'ItemId' => $similarProduct->ASIN,
						'ResponseGroup' => 'Medium,Images,VariationSummary'					
					);
					
					$similarProduct = $amazon->itemLookup($similarProductOptions);
					
					foreach($finalBannedProductArray as $bannedSimilarProduct)
					{
						
						$pos = strpos(strtolower($similarProduct->ItemAttributes->Title), strtolower($bannedSimilarProduct));
						
						if ($pos !== false)
						{							
							$addProduct = false;		
						}
					}
					
					if($addProduct)
					{
						$similarProducts[] = $similarProduct;
					}						
					
				}
			}
		}
		
		//assign global params to the view
		$view->params = $params;
		
		//assign associate tag params to the view
		$view->associateTag = $fsrAssociateTag;
		
		//assign item to the view
		$view->item = $item;
		
		//assign similar products to the view
		$view->similarProducts = $similarProducts;
		
		//setting default model
		$view->setModel($fsrPaapiConfigModel, true);
		
		$view->display();
	}
	
	private function createMenuItem2($item, $page, $itemLinkArray = null) {
        $db = &JFactory::getDBO();
		$db->setQuery('SELECT params FROM #__menu WHERE id = '.$item->id);
		
		if(!isset($itemLinkArray))
        {
        	$menuTitle = $item->title.'-'.$page;
        	$menuAlias = $item->alias.'-'.$page;
        	$menuPath = $item->alias.'-'.$page;
        	$menuParentId = 1;
        	$menuLevel = 1;
        	$menuLink = $item->link.'&page='.$page;
        	$menuParams = $db->loadResult();
        }
        else
        {
        	$menuTitle = $itemLinkArray['substrTitle'];
			$menuAlias = $itemLinkArray['linkUrl'];        	
     	
        	$menuLink = str_replace('view=fsramazon','view=fsramazonitem',$item->link).'&asin='.$itemLinkArray['asin'];
			
        	if($item->params->get('url_path') == 'use_path')
			{
				$menuPath = "";
				$menuParentId = $item->id;
				$menuLevel = $item->level + 1;
				$menuType = 'fsrhiddenmenutype';			
			}
			else
			{				
				$menuPath = $itemLinkArray['linkUrl'];
				$menuParentId = 1;
        		$menuLevel = 1;				
				$menuType = 'fsrhiddenmenutype';
			}
        	
        	$itemParams = array();
        	$itemParams['domain'] = $item->params->get('domain');
        	$itemParams['internal_link_behavior'] = $item->params->get('internal_link_behavior');
        	$itemParams['amazon_link_behavior'] = $item->params->get('amazon_link_behavior');
        	$itemParams['similar_products_num'] = $item->params->get('similar_products_num');
        	$itemParams['show_customer_reviews'] = $item->params->get('show_customer_reviews');
        	$itemParams['price'] = $item->params->get('price');        	
        	$itemParams['item_border_size'] = $item->params->get('item_border_size');
			$itemParams['item_border_color'] = $item->params->get('item_border_color');
			$itemParams['item_background_color'] = $item->params->get('item_background_color');
        	$itemParams['item_highlight_color'] = $item->params->get('item_highlight_color');
        	$itemParams['button_font_color'] = $item->params->get('button_font_color');
        	$itemParams['button_label'] = $item->params->get('button_label');
        	$itemParams['developer_links'] = $item->params->get('developer_links');
        	$itemParams['banned_products'] = $item->params->get('banned_products');
        	$itemParams['show_page_heading'] = $item->params->get('show_page_heading');
        	$itemParams['menu-meta_keywords'] = $itemLinkArray['keywords'];
        	$itemParams['menu-meta_description'] = $itemLinkArray['description'];
        	
        	$itemJsonParams = json_encode($itemParams);
        	$menuParams = $itemJsonParams;
        }
        
        
		
		$ordering = $item->ordering == 0 ? '0' : $item->ordering;
		$checkedOut = $item->checked_out == 0 ? '0' : $item->checked_out;
		$browserNav = $item->browserNav == 0 ? '0' : $item->browserNav;
		$templateStyleId = $item->template_style_id == 0 ? '0' : $item->template_style_id;
		$home = $item->home == 0 ? '0' : $item->home;
		$clientId = $item->client_id == 0 ? '0' : $item->client_id;
		
		
		
		
		$query = "" .
				"INSERT INTO `#__menu` (
					`menutype`, `title`, `alias`, `note`, `path`, 
					`link`, `type`, `published`, `parent_id`, `level`,
					`component_id`, `ordering`,	`checked_out`, `checked_out_time`, `browserNav`, 
					`access`, `img`, `template_style_id`, `params`, `home`, 
					`language`, `client_id`) 
				VALUES (
					'fsrhiddenmenutype', '$menuTitle', '$menuAlias', '', '$menuPath',
					'$menuLink', 'component', 1, $menuParentId, $menuLevel, 
					$item->component_id, $ordering, $checkedOut, '$item->checked_out_time', $browserNav, 
					$item->access, '$item->img', $templateStyleId, '$menuParams', $home, 
					'$item->language', $clientId)";
			
			$db->setQuery($query);
			
			if(!$db->query())
			{
//				return JError::raiseError( 500, "Error");
//				return JError::raiseWarning( 500, $db->getErrorMsg());
			}
			else
			{
				$db->setQuery("SELECT id FROM `#__menu` WHERE `alias` = '$menuAlias'");
			}
			
			$lastId = $db->loadResult();
			
			return $lastId;
	}			
	
/*	
	private function &createMenuItem($item, $page, $itemLinkArray = null) {
        $db   = &JFactory::getDBO();
        $menu = JTable::getInstance('menu');
        
        $db->setQuery('SELECT params FROM #__menu WHERE id = '.$item->id);
        
        $menu->menutype = 'fsrhiddenmenutype';
		$menu->note = $item->note;
		$menu->type = $item->type;
		$menu->published = 1;
		$menu->component_id = $item->component_id;
		$menu->ordering = $item->ordering;
		$menu->checked_out = $item->checked_out;
		$menu->checked_out_time = $item->checked_out_time;
		$menu->browserNav = $item->browserNav;
		$menu->access = $item->access;
		$menu->img = $item->img;
		$menu->template_style_id = $item->template_style_id;		
		$menu->home = $item->home;
		$menu->language = $item->language;
		$menu->client_id = $item->client_id;
        
        if(!isset($itemLinkArray))
        {
        	$menu->title = $item->title.'-'.$page;
        	$menu->alias = $item->alias.'-'.$page;
        	$menu->path = $item->alias.'-'.$page;
        	$menu->parent_id = 1;
        	$menu->level = 1;
        	$menu->link = $item->link.'&page='.$page;
        	$menu->params = $db->loadResult();
        }
        else
        {
        	$menu->title = $itemLinkArray['substrTitle'];
        	$menu->alias = $itemLinkArray['linkUrl'];
        	$menu->parent_id = 1;
        	$menu->level = 1;
        	$menu->path = $itemLinkArray['linkUrl'];
        	$menu->link = str_replace('view=fsramazon','view=fsramazonitem',$item->link).'&asin='.$itemLinkArray['asin'];
        	
        	$itemParams = array();
        	$itemParams['domain'] = $item->params->get('domain');
        	$itemParams['internal_link_behavior'] = $item->params->get('internal_link_behavior');
        	$itemParams['amazon_link_behavior'] = $item->params->get('amazon_link_behavior');
        	$itemParams['similar_products_num'] = $item->params->get('similar_products_num');
        	$itemParams['show_customer_reviews'] = $item->params->get('show_customer_reviews');
        	$itemParams['item_border_size'] = $item->params->get('item_border_size');
			$itemParams['item_border_color'] = $item->params->get('item_border_color');
			$itemParams['item_background_color'] = $item->params->get('item_background_color');
        	$itemParams['item_highlight_color'] = $item->params->get('item_highlight_color');
        	$itemParams['button_font_color'] = $item->params->get('button_font_color');
        	$itemParams['button_label'] = $item->params->get('button_label');
        	$itemParams['developer_links'] = $item->params->get('developer_links');
        	$itemParams['banned_products'] = $item->params->get('banned_products');
        	$itemParams['show_page_heading'] = $item->params->get('show_page_heading');
        	$itemParams['menu-meta_keywords'] = $itemLinkArray['keywords'];
        	$itemParams['menu-meta_description'] = $itemLinkArray['description'];
        	
        	$itemJsonParams = json_encode($itemParams);
        	$menu->params = $itemJsonParams;
        }

        // Figure out the order (Just pop this article at the end of the list):
        $menu->ordering = $menu->getNextOrder(
            "menutype = ".$db->Quote($menu->menutype).
            " AND published >= 0 AND parent = ".(int) $menu->parent
        );

        // Validate:
        if (!$menu->check())
            return NULL;

        // Save:
        if (!$menu->store())
            return NULL;

        // Release any checkout status:
        $menu->checkin();
        
        // Compact the menu ordering:
        $menu->reorder( 'menutype='.$db->Quote( $menu->menutype ).' AND parent='.(int)$menu->parent );
        
        //parent_id and level aren't saved so store it again       
        if(!isset($itemLinkArray))
        {
//        	$menu->parent_id = $item->id;
//			$menu->level = $item->level;
			$menu->parent_id = $item->parent_id;
	        $menu->level = 0;
	        $menu->ordering = $menu->id;
        }
        else
        {
        	// path will be computed by alias an parent
//        	$menu->parent_id = $item->id;
//	        $menu->level = $item->level + 1;
			$menu->parent_id = $item->parent_id;
	        $menu->level = 0;
	        $menu->ordering = $menu->id;
        }
        
        if (!$menu->store())
            return NULL;
            
        // Compact the menu ordering:
        $menu->reorder( 'menutype='.$db->Quote( $menu->menutype ).' AND parent='.(int)$menu->parent );
        
        return $menu;
    }
    
    */
}
