<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// no direct access
defined('_JEXEC') or die;


class JFsrFormatter
{
	/**
     * @var int
     */
    protected static $_maxTitleLength = 50; 
	
	//TODO maybe some changes need 
	/**
     * @var array
     */
    protected static $_replacements = array('ca' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
    										'cn' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
							        		'de' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
							        		'fr' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
							        		'it' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
							        		'jp' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),							        									         
							        		'uk' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')'),
											'us' => array(',', '.', "'", '"', '/', '-', '+', '*', ';', ':', '%', '&', '(', ')')
							        		);
	
	//TODO maybe some changes need 
	/**
     * @var array
     */
    protected static $_specialCharReplacements = array(
		'ca' => array(),
		'cn' => array(),
		'de' => array(
			array('search' => 'Ä', 'replace' => 'Ae'),
			array('search' => 'Ö', 'replace' => 'Oe'),
			array('search' => 'Ü', 'replace' => 'Ue'),
			array('search' => 'ä', 'replace' => 'ae'),
			array('search' => 'ö', 'replace' => 'oe'),
			array('search' => 'ü', 'replace' => 'ue'),
			array('search' => 'ß', 'replace' => 'ss')
		),
		'fr' => array(),
		'it' => array(),
		'jp' => array(),		
		'uk' => array(),
		'us' => array()		
	);
	
	//TODO maybe some changes need 
	/**
     * @var array
     */
    protected static $_keywordFillWordReplacements = array(
		'ca' => array('a', 'to', 'the', 'for', 'with', 'and', 'in'),
		'cn' => array(),
		'de' => array('der', 'die', 'das', 'des', 'ein', 'eine', 'und', 'oder', 'für', 'als', 'zum', 'auf', 'an', 'zu', 'in', 'auch', 'nur', 'aufs', 'mit'),
		'fr' => array(),
		'it' => array(),
		'jp' => array(),		
		'uk' => array('a', 'to', 'the', 'for', 'with', 'and', 'in'),
		'us' => array('a', 'to', 'the', 'for', 'with', 'and', 'in')		
	);
	
	//TODO maybe some changes need 
	/**
     * @var array
     */
    protected static $_descriptionPatterns = array(
		'ca' => '<product>',
		'cn' => '<product>',
		'de' => 'Hier finden Sie Produkt-Details zu <product> und können günstig online bestellen.',
		'fr' => '<product>',
		'it' => '<product>',
		'jp' => '<product>',		
		'uk' => '<product>',
		'us' => '<product>'		
	);

	//TODO maybe some changes need 	
	/**
     * @var array
     */
    protected static $_promotionWords = array(
		'ca' => array('cheap'),
		'cn' => array(),
		'de' => array('günstig'),
		'fr' => array(),
		'it' => array(),
		'jp' => array(),		
		'uk' => array('cheap'),
		'us' => array('cheap')		
	);
	
	/**
	 * @param string
	 * @param string
	 * @param string
	 * @return array with additional link data
	 */
	static function itemAdditionalLinkData($countryCode, $title, $asin)
    {
	
		//create title
	
    	if(strlen($title) > self::$_maxTitleLength)
		{
			$substrTitle1 = substr($title, 0, self::$_maxTitleLength);
							
			$substrTitle2 = substr($title, self::$_maxTitleLength);
			
			if(strpos($substrTitle2, ' ') !== false)
			{
				$substrTitle2 = substr($substrTitle2, 0, strpos($substrTitle2, ' '));
			}
							
			$substrTitle = $substrTitle1.$substrTitle2;
			
		}
		else
		{
			$substrTitle = $title;
		}
		
		//create link
		
		$link = $substrTitle;
		
		$replacements = self::$_replacements[$countryCode];
		
		foreach($replacements as $replacement)
		{
			$link = str_replace($replacement, ' ', $link);
		}		
		
		foreach(self::$_specialCharReplacements[$countryCode] as $replacement)
		{
			$link = str_replace($replacement['search'], $replacement['replace'], $link);
		}
		
		while(strpos($link, '  ') !== false)
		{
			$link = str_replace('  ', ' ', $link);
		}
		
		//remove last blank
		while(preg_match("/.* $/", $link)) {
  			$link = substr($link, 0, strlen($link) -1);
		}
		
		$link = str_replace(' ', '-', $link);
		
		$link = strtolower($link);
		
		$link = $link."-".substr(md5($asin), 0, 5);
		
		//create keywords
		
		$keywords = $substrTitle;
		
		$replacements = self::$_replacements[$countryCode];
		
		foreach($replacements as $replacement)
		{
			$keywords = str_replace($replacement, ' ', $keywords);
		}
		
		$fillReplacements = self::$_keywordFillWordReplacements[$countryCode];
			
		$fillRegexReplacement = array();
		
		foreach($fillReplacements as $fillReplacement)
		{
			$fillRegexReplacement[] = '#[\s]{1,}'.$fillReplacement.'[\s]{1,}#';
			//$keywords = str_replace($fillReplacement, ' ', $keywords);
		}
		
		$keywords = preg_replace($fillRegexReplacement, ' ', strtolower($keywords));
		
//		foreach(self::$_specialCharReplacements[$countryCode] as $replacement)
//		{
//			$keywords = str_replace($replacement['search'], $replacement['replace'], $keywords);
//		}
		
		while(strpos($keywords, '  ') !== false)
		{
			$keywords = str_replace('  ', ' ', $keywords);
		}
		
		$keywordArray = array_unique(explode(' ', $keywords));
			
		$promotionWords = self::$_promotionWords[$countryCode];
			
		$counter = 1;
		
		$numKeywords = 10 - count($promotionWords);
		
		foreach($keywordArray as $keyword)
		{
			if($counter < $numKeywords && $counter < count($keywordArray))
			{
				$finalKeywords .= $keyword.', ';
			}
			else if($counter < $numKeywords || $counter == count($keywordArray))
			{
				$finalKeywords .= $keyword;
			}
			
			$counter++;	
		}
		
		foreach($promotionWords as $promotionWord)
		{
			
//			foreach(self::$_specialCharReplacements[$countryCode] as $replacement)
//			{
//				$promotionWord = str_replace($replacement['search'], $replacement['replace'], $promotionWord);
//			}
			
			$finalKeywords .= ', '.$promotionWord;
	
		}
		
		$description = self::$_descriptionPatterns[$countryCode];
		$description = str_replace('<product>', $title, $description);
		
        return array('substrTitle' => $substrTitle, 'linkUrl' => $link, 'keywords' => $finalKeywords, 'description' => $description);		
		
    }

}
