<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla modelitem library
jimport('joomla.application.component.modelitem');

/**
 * FsrMenuMemory Model
 */
class FsrAmazonModelFsrMenuMemory extends JModelItem
{
	/**
	 * @var object config
	 */
	protected $config;
	
	/**
	 * @var array refresh interval
	 */
	protected $refreshIntervalArray = array(
		'always'=> -1,
		'day'   => 1,
		'week'  => 7,
		'month' => 30
	);


//	/**
//	 * Method to auto-populate the model state.
//	 *
//	 * This method should only be called once per instantiation and is designed
//	 * to be called on the first call to the getState() method unless the model
//	 * configuration flag to ignore the request is set.
//	 *
//	 * Note. Calling getState in this method will result in recursion.
//	 *
//	 * @return	void
//	 * @since	1.6
//	 */
//	protected function populateState() 
//	{
////		$app = JFactory::getApplication();
//		
//		// Get the aws config id
//		$aws_id = JRequest::getInt('aws_id');
//		$this->setState('awsconfig.id', $aws_id);
//
//		// Load the parameters.
////		$params = $app->getParams();
////		$this->setState('params', $params);
//		parent::populateState();
//	}

	/**
	 * Returns a reference to the Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string 	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'FsrMenuMemory', $prefix = 'FsrAmazonTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	
	/**
	 * checks if a page is expired
	 * 
	 * @param int id of menu item
	 * @param boolean flag indicates if page is an initiator
	 * @return boolean
	 */
	public function isExpired($menuId, $initiator = false, $asin = null) 
	{
		
		$this->_db->setQuery(
			$this->_db->getQuery(true)
			->select('mm.*')
			->from('#__fsramazon_menu_memory AS mm')			
			->where("mm.expiration_date>=DATE_FORMAT(NOW(), '%Y-%m-%d')")
		);
		
		if(isset($asin))
		{
			$this->_db->setQuery($this->_db->getQuery()
				->where("mm.asin = '".$asin."1'")
				->where("mm.initiator='0'"));
		}
		else
		{	
			$this->_db->setQuery($this->_db->getQuery()
					->where('mm.menu_id=' . (int)$menuId));
			
			if($initiator)
			{
				$this->_db->setQuery($this->_db->getQuery()
					->where("mm.initiator='1'"));
			}
			else
			{
				$this->_db->setQuery($this->_db->getQuery()
					->where("mm.initiator='0'"));
			}
		}		
								
		if ($menu = $this->_db->loadObject()) 
		{
			return false;
		}
		else
		{
			return true;
		}

	}
	
	/**
	 * remove expired menu items
	 * @param boolean flag indicates if page is an initiator
	 * @return void
	 */
	public function refreshMenuItems($initiator = false) 
	{
		
		$initiatorString = $initiator ? "'1'" : "'0'";
							
		$query = "" .
			"DELETE FROM `#__menu` " .
			"WHERE id IN (" .
				"SELECT menu_id FROM `#__fsramazon_menu_memory` " .
				"WHERE `expiration_date` < DATE_FORMAT(NOW(), '%Y-%m-%d') " .
				"AND `initiator` = ".$initiatorString.
			")";
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}
		
		$query = "" .
			"DELETE FROM `#__fsramazon_menu_memory` " .
			"WHERE `expiration_date` < DATE_FORMAT(NOW(), '%Y-%m-%d') " .
			"AND `initiator` = ".$initiatorString;
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}

	}
	
	/**
	 * remove menu item by parent 
	 * @param string parent menu id
	 * @return void
	 */
	public function removeByParent($parentMenuId = null) 
	{
		$query = "" .
			"DELETE FROM `#__menu` " .
			"WHERE id IN (" .
				"SELECT menu_id FROM `#__fsramazon_menu_memory` " .
				"WHERE `parent_menu_id` = ".$parentMenuId .
			")";
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}
		
		$query = "" .
			"DELETE FROM `#__fsramazon_menu_memory` " .
			"WHERE `parent_menu_id` = ".$parentMenuId;
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}
	}
	
	/**
	 * remove menu item by asin 
	 * @param string amazon asin
	 * @return void
	 */
	public function removeByAsin($asin = null) 
	{
		$query = "" .
			"DELETE FROM `#__menu` " .
			"WHERE id IN (" .
				"SELECT menu_id FROM `#__fsramazon_menu_memory` " .
				"WHERE `asin` = '".$asin."'" .
			")";
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}
		
		$query = "" .
			"DELETE FROM `#__fsramazon_menu_memory` " .
			"WHERE `asin` = '".$asin."'";
		
		$this->_db->setQuery($query);
		
		if(!$this->_db->query())
		{
			//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
		}
	}
	
	/**
	 * checks if a page is expired
	 * 
	 * @param int id of menu item
	 * @param string expiration interval
	 * @param boolean flag indicates if page is an initiator
	 * @param string amazon asin
	 * @return boolean
	 */
	public function create($menuId, $parentMenuId=null, $expirationInterval = 'day', $initiator = false, $asin = null) 
	{
		
		//check if entry already exists
		
		$this->_db->setQuery(
			$this->_db->getQuery(true)
			->select('mm.*')
			->from('#__fsramazon_menu_memory AS mm')			
		);
		
		//page is a item index and identified by menu id 
		if(!isset($asin))
		{
			$this->_db->setQuery($this->_db->getQuery()
				->where('mm.menu_id=' . (int)$menuId)
				->where('mm.asin IS NULL')
			);
		} //page is a item page
		else
		{
			$this->_db->setQuery($this->_db->getQuery()
				->where("mm.asin='".$asin."'"));
		}
		
		if($menu = $this->_db->loadObject()) 
		{
			
			$query = "" .
				"UPDATE `#__fsramazon_menu_memory` " .
				"SET `expiration_date` = DATE_ADD(NOW(), INTERVAL ".$this->refreshIntervalArray[$expirationInterval]." DAY)";
			
			//page is a item index and identified by menu id 
			if(!isset($asin))
			{
				$query .= "WHERE id = " . $menu->id;
			} //page is a item page
			else
			{
				$query .= "WHERE asin = '".$asin."'";
			}
			
			$this->_db->setQuery($query);
			
			if(!$this->_db->query())
			{
				//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
			}
			
		}
		else
		{
			//pages with asin are never initiator pages
			$initiatorString = ($initiator && !isset($asin)) ? "'1'" : "'0'";
			
			$asinString = isset($asin) ? "'".$asin."'" : "NULL";
			
			$parentMenuIdString = isset($parentMenuId) ? $parentMenuId : "NULL";
			
			$query = "" .
				"INSERT INTO `#__fsramazon_menu_memory` " .
				"(`menu_id`, `parent_menu_id`, `initiator`, `asin`, `expiration_date`) " .
				"VALUES (".$menuId.", ".$parentMenuIdString.", ".$initiatorString.", ".$asinString.", DATE_ADD(NOW(), INTERVAL ".$this->refreshIntervalArray[$expirationInterval]." DAY))";
			
			$this->_db->setQuery($query);
			
			if(!$this->_db->query())
			{
				//return JError::raiseWarning( 500, $this->_db->getErrorMsg());
			}
		}
	}
	
	
}
