<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

// import Joomla modelitem library
jimport('joomla.application.component.modelitem');

/**
 * FsrPaapiConfig Model
 */
class FsrAmazonModelFsrPaapiConfig extends JModelItem
{
	/**
	 * @var object config
	 */
	protected $config;


	/**
	 * Method to auto-populate the model state.
	 *
	 * This method should only be called once per instantiation and is designed
	 * to be called on the first call to the getState() method unless the model
	 * configuration flag to ignore the request is set.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @return	void
	 * @since	1.6
	 */
	protected function populateState() 
	{
//		$app = JFactory::getApplication();
		
		// Get the paapi config id
		$paApiId = JRequest::getInt('paapi_id');
		$this->setState('paapiconfig.id', $paApiId);

		// Load the parameters.
//		$params = $app->getParams();
//		$this->setState('params', $params);
		parent::populateState();
	}

	/**
	 * Returns a reference to the Table object, always creating it.
	 *
	 * @param	type		The table type to instantiate
	 * @param	string 	A prefix for the table class name. Optional.
	 * @param	array		Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'FsrPaapiConfig', $prefix = 'FsrPaapiConfigTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	/**
	 * Get the paapi config
	 * @return object The paapi config to used for product advertising api
	 */
	public function getConfig() 
	{
		if (!isset($this->config)) 
		{
			$id = $this->getState('paapiconfig.id');
			$this->_db->setQuery($this->_db->getQuery(true)
				->from('#__fsramazon_paapi_configs as paapi')
				->select('paapi.*')
				->where('paapi.id=' . (int)$id));
			if (!$this->config = $this->_db->loadObject()) 
			{
				$this->setError($this->_db->getError());
			}
			else
			{
				// Load the JSON string
				$params = new JRegistry;
				$params->loadJSON($this->config->params);
				$this->config->params = $params;

				// Merge global params with config params
//				$params = clone $this->getState('params');
//				$params->merge($this->config->params);
//				$this->config->params = $params;
			}
		}
		return $this->config;
	}
}
