<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'helpers'.DS.'fsrformatter.php');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'fsrranddonate.php');

?>
<div class="item-page">
	<h1 class="fsramazon-h1"><?php echo $this->title; ?></h1>
	
	<?php 
	
		$counter = 0;
		
		$borderSize = $this->params->get('item_border_size')."px";
		$borderColor = $this->params->get('item_border_color');
		$boxColor = $this->params->get('item_background_color');
		$highlightColor = $this->params->get('item_highlight_color');
		$buttonFontColor = $this->params->get('button_font_color');
		$imageSize = $this->params->get('item_image_size');
		$buttonLabel = $this->params->get('button_label') != '' ? $this->params->get('button_label') : JText::_('COM_FSRAMAZON_FSRAMAZON_PARAM_BUTTON_LABEL_DEFAULT');
		
		$internalLinkBehaviorString = $this->params->get('internal_link_behavior') == '_blank' ? 'target="_blank"' : '';
		$amazonLinkBehaviorString = $this->params->get('amazon_link_behavior') == '_blank' ? 'target="_blank"' : '';
	
	?>
	
	<?php foreach($this->resultset->getItems() as $item) : ?>
		<?php $link = JFsrFormatter::itemAdditionalLinkData($this->params->get('domain'), $item->ItemAttributes->Title, $item->ASIN); ?>
		
		<?php if($this->params->get('developer_links') == 'show_links') : ?>
			<?php $amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$item->ASIN."?ie=UTF8&tag=".$this->associateTag; ?>
		<?php elseif($this->params->get('developer_links') == 'show_links_and_donate') : ?>
			<?php 
				$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 2);
				$amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$item->ASIN."?ie=UTF8&tag=".$associateTag;
			?>
		<?php elseif($this->params->get('developer_links') == 'donate') : ?>
			<?php 
				$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 5);
				$amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$item->ASIN."?ie=UTF8&tag=".$associateTag;
			?>
		<?php endif ?>
		
		<?php if($this->params->get('index_behavior') == 'item_page') : ?>
			<?php $productLink = ($this->parentPath == '') ? $link['linkUrl'] : $this->parentPath."/".$link['linkUrl']; ?>
			<?php $follow = ""; ?>
		<?php else : ?>
			<?php $productLink = $amazonLink; ?>
			<?php $follow = "rel=\"nofollow\""; ?>
		<?php endif ?>
		
		<?php $showThisProduct = true; ?>
		
		<?php
		 
			foreach($this->bannedProducts as $bannedProduct)
			{
				$pos = strpos(strtolower($item->ItemAttributes->Title), strtolower($bannedProduct));
				
				if ($pos !== false)
				{					
					$showThisProduct = false;
				}				
			}
		?>
		
		<div style="width: 50%; float: <?php echo ($counter % 2 == 0) ? 'left' : 'right'; ?>;">
			<div style="min-height: <?php echo ($imageSize == 'small') ? '165px' : '250px' ; ?>; background-color: <?php echo $borderColor; ?>; padding: <?php echo $borderSize; ?>; margin: <?php echo ($counter % 2 == 0) ? '4px 2% 4px 2%' : '4px 2% 4px 2%'; ?>;">
				<div style="min-height: <?php echo ($imageSize == 'small') ? '165px' : '250px' ; ?>; padding: 3px; background-color: <?php echo $boxColor; ?>;">
					<div style="height: 55px">
						<?php if($showThisProduct) : ?>
							<a style="text-decoration: none;" href="<?php echo $productLink;?>" <?php echo $follow;?> <?php echo $internalLinkBehaviorString; ?> title="<?php echo $link['substrTitle']; ?>">
								<h2 class="fsramazon-h2-item" style="color: <?php echo $highlightColor; ?>;">
									<?php echo $link['substrTitle']; ?>
								</h2>
							</a>
						<?php else : ?>
							<h2><?php echo JText::_('COM_FSRAMAZON_PRODUCT_NOT_FOUND'); ?></h2>
						<?php endif ?>
					</div>
					<div style="float: left; width: 40%; min-width: <?php echo ($imageSize == 'small') ? '75px' : '160px'; ?>;margin: 0 5px 5px 0;">
						<?php if($showThisProduct) : ?>
							<a style="text-decoration: none;" href="<?php echo $amazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $item->ItemAttributes->Title;?>" rel="nofollow">
						<?php endif ?>
							<?php 
								
								if($imageSize == 'small' )
								{
									if(isset($item->SmallImage->URL) && $showThisProduct)
									{
										$imageString = '<img src="'.$item->SmallImage->URL.'" title="'.$link['substrTitle'].'" alt="Product icon of '.$link['substrTitle'].'"/><br/><br/>';
									}
									else
									{
										$imageString = '<div style="width: 75px; height: 25px; text-align: center; font-weight: bold; border: solid 1px '.$highlightColor.'; padding: 25px 0px;">&nbsp;</div>';
									}
								}
								else
								{
									if(isset($item->MediumImage->URL) && $showThisProduct)
									{
										$imageString = '<img src="'.$item->MediumImage->URL.'" title="'.$link['substrTitle'].'" alt="Product icon of '.$link['substrTitle'].'"/><br/><br/>';
									}
									else
									{
										$imageString = '<div style="width: 160px; height: 30px; text-align: center; font-weight: bold; border: solid 1px '.$highlightColor.'; padding: 65px 0px;">&nbsp;	</div>';
									}
								}
								
								echo $imageString; ?>
						<?php if($showThisProduct) : ?>
							</a>
						<?php endif ?>
					</div>
					<div style="float: right; width: 50%; margin: 0 0 5px 0; text-align: left;">
						<?php 
							if(isset($item->OfferSummary->LowestNewPrice->FormattedPrice))
							{
								$price = $item->OfferSummary->LowestNewPrice->FormattedPrice;
							}
							elseif(isset($item->Offers->Offer->Price->FormattedPrice))
							{
								$price = $item->Offers->Offer->Price->FormattedPrice;
							}
							elseif(isset($item->VariationSummary->LowestPrice->FormattedPrice) && isset($item->VariationSummary->HighestPrice->FormattedPrice))
							{
								$price = $item->VariationSummary->LowestPrice->FormattedPrice." - ".$item->VariationSummary->HighestPrice->FormattedPrice;
							}
							else
							{
								$price = "";
							}						
						?>
						<?php $price = isset($item->OfferSummary->LowestNewPrice->FormattedPrice) ? $item->OfferSummary->LowestNewPrice->FormattedPrice : $item->Offers->Offer->Price->FormattedPrice; ?>
						<span style="font-weight: bold; font-size: 14px; color: <?php echo $highlightColor; ?>;"><?php if(($this->params->get('price') == 'yes') && ($showThisProduct)) : ?><?php echo $price; ?><?php endif ?></span>
						<?php echo ($imageSize == 'small') ? '<br /><br />' : '<br /><br /><br />' ; ?>
						<?php if($showThisProduct) : ?>
							<a style="text-decoration: none;" href="<?php echo $amazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $buttonLabel.' - '.$link['substrTitle']; ?>" rel="nofollow">
								<div style="height: 14px; max-width: 150px; text-align: center; padding: 8px 10px; font-weight: bold; font-size: 1.2em; color: <?php echo $buttonFontColor; ?>; background-image: url(<?php echo JURI::base().'components/com_fsramazon/img/button-big.jpg'; ?>); background-repeat: repeat-x; border: 1px solid #e1e1e1; border-bottom-color: #cccccc;">
									<?php echo $buttonLabel; ?>
								</div>
							</a>
						<?php else : ?>
							<div style="height: 14px; max-width: 150px; text-align: center; padding: 8px 10px; font-weight: bold; font-size: 1.2em; color: <?php echo $buttonFontColor; ?>; background-image: url(<?php echo JURI::base().'components/com_fsramazon/img/button-big.jpg'; ?>); background-repeat: repeat-x; border: 1px solid #e1e1e1; border-bottom-color: #cccccc;">
								<?php echo $buttonLabel; ?>
							</div>
						<?php endif ?>
					</div>
					<div style="clear: both;"></div>
				</div>
			</div>
			<?php if($counter == 9) : ?>
				<?php if($this->params->get('developer_links') == 'show_links' || $this->params->get('developer_links') == 'show_links_and_donate') : ?>
					<div style="text-align: right; font-size: 0.8em; margin-right: 2%;">
						<?php if($this->params->get('domain') == 'de') : ?>
							free <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de/fsramazon-joomla-amazon-modul-komponente-plugin-kostenlos.html" title="kostenlose Joomla Amazon Komponente (Plugin / Modul)">fsramazon</a> by <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de" title="1sr - fist search result">1sr</a>
						<?php else : ?>				
							free <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de/fsramazon-joomla-amazon-modul-komponente-plugin-kostenlos/free-joomla-amazon-module-component-plugin.html" title="free joomla amazon component">fsramazon</a> by <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de" title="1sr - fist search result">1sr</a>
						<?php endif ?>
					</div>				
				<?php endif ?>			
			<?php endif ?>
		</div>
		
		<?php if($counter % 2 != 0) : ?>
			<div style="clear: both;"></div>
		<?php endif ?>
		
		<?php $counter++; ?>	
		
	<?php endforeach ?>
	
	<div class="pagination">

		<?php // if ($this->params->def('show_pagination_results', 1)) : ?>
			<p class="counter">
				<?php echo $this->pagination->getPagesCounter(); ?>
			</p>
		<?php  // endif; ?>
				<?php echo $this->pagination->getPagesLinks(); ?>
	</div>
	
</div>	