<?php

/**
 * @copyright	Copyright (C) 2011 1sr, Inc. All rights reserved.
 * @author		1sr
 * @link		http://1sr.de/fsramazon
 * @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

require_once(JPATH_COMPONENT.DS.'helpers'.DS.'fsrformatter.php');
require_once(JPATH_COMPONENT.DS.'helpers'.DS.'fsrranddonate.php');

?>
<?php
	
	$borderSize = $this->params->get('item_border_size')."px";
	$borderColor = $this->params->get('item_border_color');
	$boxColor = $this->params->get('item_background_color');
	$highlightColor = $this->params->get('item_highlight_color');
	$buttonFontColor = $this->params->get('button_font_color');
	$buttonLabel = $this->params->get('button_label') != '' ? $this->params->get('button_label') : JText::_('COM_FSRAMAZON_FSRAMAZON_PARAM_BUTTON_LABEL_DEFAULT');	
		
	$amazonLinkBehaviorString = $this->params->get('amazon_link_behavior') == '_blank' ? 'target="_blank"' : '';

if($this->params->get('developer_links') == 'show_links')
{
	$amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$this->item->ASIN."?ie=UTF8&tag=".$this->associateTag;
}
elseif($this->params->get('developer_links') == 'show_links_and_donate')
{
	$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 2);
	$amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$this->item->ASIN."?ie=UTF8&tag=".$associateTag;
}
elseif($this->params->get('developer_links') == 'donate')
{
	$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 5);
	$amazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$this->item->ASIN."?ie=UTF8&tag=".$associateTag;
}

?>

<div class="item-page">
	<?php $link = JFsrFormatter::itemAdditionalLinkData($this->params->get('domain'), $this->item->ItemAttributes->Title, $this->item->ASIN); ?>
	<h1 class="fsramazon-h1"><?php echo $this->item->ItemAttributes->Title; ?></h1>

	<div style="float: left; width: 160px; height: 160px; margin-right: 10px; margin-top: 5px;">
		<a href="<?php echo $amazonLink;?>" <?php echo $amazonLinkBehaviorString;?> title="<?php echo $this->item->ItemAttributes->Title; ?>" rel="nofollow">
			<?php echo (isset($this->item->MediumImage->URL)) ? '<img src="'.$this->item->MediumImage->URL.'" title="'.$this->item->ItemAttributes->Title.'" alt="'.$this->item->ItemAttributes->Title.'"\>' : '<div style="width: 160px; height: 30px; text-align: center; font-weight: bold; border: solid 1px '.$highlightColor.'; padding: 65px 0px;">&nbsp;</div>'; ?>
		</a>
	</div>
	<div style="float: left; width: 160px; height: 130px; padding-top: 30px; margin-left: 50px; margin-top: 5px;">
		<?php 
			if(isset($this->item->OfferSummary->LowestNewPrice->FormattedPrice))
			{
				$price = $this->item->OfferSummary->LowestNewPrice->FormattedPrice;
			}
			elseif(isset($this->item->Offers->Offer->Price->FormattedPrice))
			{
				$price = $this->item->Offers->Offer->Price->FormattedPrice;
			}
			elseif(isset($this->item->VariationSummary->LowestPrice->FormattedPrice) && isset($this->item->VariationSummary->HighestPrice->FormattedPrice))
			{
				$price = $this->item->VariationSummary->LowestPrice->FormattedPrice." - ".$this->item->VariationSummary->HighestPrice->FormattedPrice;
			}
			else
			{
				$price = "";
			}						
		?>
		<span style="font-weight: bold; font-size: 14px; color: <?php echo $highlightColor; ?>;"><?php if($this->params->get('price') == 'yes') : ?><?php echo $price; ?><?php endif ?></span>
		<br/><br/>
		<a style="text-decoration: none;" href="<?php echo $amazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $buttonLabel.' - '.$link['substrTitle']; ?>" rel="nofollow">
			<div style="height: 14px; max-width: 150px; text-align: center; padding: 8px 10px; font-weight: bold; font-size: 1.2em; color: <?php echo $buttonFontColor; ?>; background-image: url(<?php echo JURI::base().'components/com_fsramazon/img/button-big.jpg'; ?>); background-repeat: repeat-x; border: 1px solid #e1e1e1; border-bottom-color: #cccccc;">
				<?php echo $buttonLabel; ?>
			</div>
		</a>
	</div>
	
	<div style="clear: both;"></div>
	
	<br/>
	<h2><?php echo JText::_('COM_FSRAMAZON_PRODUCT_INFORMATION'); ?></h2>
	<?php if($this->item->ItemAttributes->Feature) : ?>
		<h3><?php echo JText::_('COM_FSRAMAZON_PRODUCT_DETAILS'); ?></h3>
		<ul>
		<?php foreach($this->item->ItemAttributes->Feature as $feature) : ?>
		<?php
			 
			$showDetail = true;
			
			foreach($this->bannedProducts as $bannedProduct)
			{
				
				$pos = strpos(strtolower($feature), strtolower($bannedProduct));
				
				if ($pos !== false)
				{
					$showDetail = false;
				}
			}
		 ?>
		 
		 <?php if($showDetail) : ?>		
			<li><?php echo $feature; ?></li>
		<?php endif ?>
		<?php endforeach ?>
		</ul>
	<?php endif ?>
	
	<?php if($this->item->EditorialReviews->EditorialReview->Content) : ?>
	<h3><?php echo JText::_('COM_FSRAMAZON_PRODUCT_DESCRIPTION'); ?></h3>
	<br/>
	<?php
			 
		$showDetail = true;
		
		foreach($this->bannedProducts as $bannedProduct)
		{
			
			$pos = strpos(strtolower($this->item->EditorialReviews->EditorialReview->Content), strtolower($bannedProduct));
			
			if ($pos !== false)
			{
				$showDetail = false;
			}
		}
	 ?>
	 
		<?php if($showDetail) : ?>		
			<?php echo $this->item->EditorialReviews->EditorialReview->Content; ?>
		<?php endif ?>
	<br/><br/>
	<?php endif ?>
	
	<?php if(count($this->similarProducts) > 0) : ?>
	<h3><?php echo JText::_('COM_FSRAMAZON_RELATED_ITEMS'); ?></h3>
	<br/>
	
		<?php
			
			$counter = 0;
		?>
		
		<?php foreach($this->similarProducts as $similarProduct) : ?>
			
			<?php $similarProductLink = JFsrFormatter::itemAdditionalLinkData($this->params->get('domain'), $similarProduct->ItemAttributes->Title, $similarProduct->ASIN); ?>
			
			<?php if($this->params->get('developer_links') == 'show_links') : ?>
				<?php $similarProductAmazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$similarProduct->ASIN."?ie=UTF8&tag=".$this->associateTag; ?>
			<?php elseif($this->params->get('developer_links') == 'show_links_and_donate') : ?>
				<?php 
					$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 2);
					$similarProductAmazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$similarProduct->ASIN."?ie=UTF8&tag=".$associateTag;
				?>
			<?php elseif($this->params->get('developer_links') == 'donate') : ?>
				<?php 
					$associateTag = JFsrRandDonate::getRandomAssociationTag($this->associateTag, $this->params->get('domain'), 5);
					$similarProductAmazonLink = JFsrRandDonate::getAssociationUrl($this->params->get('domain')).$similarProduct->ASIN."?ie=UTF8&tag=".$associateTag;
				?>
			<?php endif ?>
				
			
			<div style="width: 50%; float: <?php echo ($counter % 2 == 0) ? 'left' : 'right'; ?>;">
				<div style="min-height: 165px; background-color: <?php echo $borderColor; ?>; padding: <?php echo $borderSize; ?>; margin: <?php echo ($counter % 2 == 0) ? '4px 2% 4px 2%' : '4px 2% 4px 2%'; ?>;">
					<div style="min-height: 165px; padding: 3px; background-color: <?php echo $boxColor; ?>;">
						<div style="height: 55px">
							<a style="text-decoration: none;" href="<?php echo $similarProductAmazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $similarProductLink['substrTitle']; ?>" rel="nofollow">
								<h2 class="fsramazon-h2-item" style="color: <?php echo $highlightColor; ?>;"><?php echo $similarProductLink['substrTitle']; ?></h2>
							</a>
						</div>
						<div style="float: left; width: 40%; min-width: 75px;margin: 0 5px 5px 0;">
							<a style="text-decoration: none;" href="<?php echo $similarProductAmazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $similarProduct->ItemAttributes->Title;?>" rel="nofollow">
								<?php 
									
									if(isset($similarProduct->SmallImage->URL))
									{
										$imageString = '<img src="'.$similarProduct->SmallImage->URL.'" title="'.$similarProductLink['substrTitle'].'" alt="Product icon of '.$similarProductLink['substrTitle'].'"/><br/><br/>';
									}
									else
									{
										$imageString = '<div style="width: 75px; height: 25px; text-align: center; font-weight: bold; border: solid 1px '.$highlightColor.'; padding: 25px 0px;">&nbsp;</div>';
									}								
									
									echo $imageString; ?>
							</a>
						</div>
						<div style="float: right; width: 50%; margin: 0 0 5px 0; text-align: left;">
							<?php $similarProductPrice = isset($similarProduct->OfferSummary->LowestNewPrice->FormattedPrice) ? $similarProduct->OfferSummary->LowestNewPrice->FormattedPrice : $similarProduct->Offers->Offer->Price->FormattedPrice; ?>
							<?php 
								if(isset($similarProduct->OfferSummary->LowestNewPrice->FormattedPrice))
								{
									$similarProductPrice = $similarProduct->OfferSummary->LowestNewPrice->FormattedPrice;
								}
								elseif(isset($similarProduct->Offers->Offer->Price->FormattedPrice))
								{
									$similarProductPrice = $similarProduct->Offers->Offer->Price->FormattedPrice;
								}
								elseif(isset($similarProduct->VariationSummary->LowestPrice->FormattedPrice) && isset($similarProduct->VariationSummary->HighestPrice->FormattedPrice))
								{
									$similarProductPrice = $similarProduct->VariationSummary->LowestPrice->FormattedPrice." - ".$similarProduct->VariationSummary->HighestPrice->FormattedPrice;
								}
								else
								{
									$similarProductPrice = "";
								}						
							?>
							<span style="font-weight: bold; font-size: 14px; color: <?php echo $highlightColor; ?>;"><?php if($this->params->get('price') == 'yes') : ?><?php echo $similarProductPrice; ?><?php endif ?></span>
							<?php echo ($imageSize == 'small') ? '<br /><br />' : '<br /><br /><br />' ; ?>
							<a style="text-decoration: none;" href="<?php echo $similarProductAmazonLink;?>" <?php echo $amazonLinkBehaviorString; ?> title="<?php echo $buttonLabel.' - '.$similarProductLink['substrTitle']; ?>" rel="nofollow">
								<div style="height: 14px; max-width: 150px; text-align: center; padding: 8px 10px; font-weight: bold; font-size: 1.2em; color: <?php echo $buttonFontColor; ?>; background-image: url(<?php echo JURI::base().'components/com_fsramazon/img/button-big.jpg'; ?>); background-repeat: repeat-x; border: 1px solid #e1e1e1; border-bottom-color: #cccccc;">
									<?php echo $buttonLabel; ?>
								</div>
							</a>
						</div>
						<div style="clear: both;"></div>
					</div>
				</div>
			</div>
			
			<?php if(($counter % 2 != 0) || ($counter == count($this->similarProducts) - 1)) : ?>
				<div style="clear: both;"></div>
			<?php endif ?>
			
			<?php $counter++; ?>	
			
		<?php endforeach ?>
	<br /><br />
	<?php endif ?>
	
	<?php if(($this->item->CustomerReviews->IFrameURL) && ($this->params->get('show_customer_reviews') == 'yes')): ?>
		<h3><?php echo JText::_('COM_FSRAMAZON_CUSTOMER_REVIEWS'); ?></h3>
		<iframe marginwidth="0" marginheight="0" height="1100px" width="98%" src="<?php echo $this->item->CustomerReviews->IFrameURL; ?>" frameborder="0" scrolling="yes">
			<p><?php echo JText::_('COM_FSRAMAZON_IFRAME_NOT_SUPPORTED'); ?></p>
		</iframe>
	<?php endif ?>
	
	<?php if($this->params->get('developer_links') == 'show_links' || $this->params->get('developer_links') == 'show_links_and_donate') : ?>
		<div style="text-align: right; font-size: 0.8em; margin-right: 2%;">
			<?php if($this->params->get('domain') == 'de') : ?>
				free <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de/fsramazon-joomla-amazon-modul-komponente-plugin-kostenlos.html" title="kostenlose Joomla Amazon Komponente (Plugin / Modul)">fsramazon</a> by <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de" title="1sr - fist search result">1sr</a>
			<?php else : ?>				
				free <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de/fsramazon-joomla-amazon-modul-komponente-plugin-kostenlos/free-joomla-amazon-module-component-plugin.html" title="free joomla amazon component">fsramazon</a> by <a style="color: <?php echo $highlightColor; ?>;" href="http://www.1sr.de" title="1sr - fist search result">1sr</a>
			<?php endif ?>
		</div>				
	<?php endif ?>
	
</div>